--------------------------------------------------------------
-- If testing in a non-production system do the following:
--
--     USE DynamicsPerf
--STEP1
-- 		EXEC SP_PURGESTATS @PURGE_DAYS = -1
--			 ,@DATABASE_NAME = 'XXXXXXXX'  --Use this option to delete all data for 1 database
--     GO
--		--	Be sure all users are out of the test database
--		--	Get yourself to the point in the application where you are ready to push the button for the code
--		--		you want to review.
--
--STEP2
--		DBCC FREEPROCCACHE
-- or the follwing for a specific database
--
--		DECLARE @intDBID INTEGER SET @intDBID = (SELECT dbid FROM master.dbo.sysdatabases WHERE name = database_name) 
--		DBCC FLUSHPROCINDB (@intDBID)
--
--
-- Capture data enabling delta's to be calculated
--
-- STEP3
--  USE DynamicsPerf
--  EXEC SP_CAPTURESTATS	@DATABASE_NAME = 'XXXXXXXXX'
--
--
-- STEP4
--		--Now run your tests
--
-- STEP5 capture data again

-- --------------------------------------------------------------
-- Script to execute SP_CAPTURESTATS
--
-- The run name is output at completion:
--	 RUN NAME = TEST1
-- This date/time is then used to predicate 
-- subsequent queries to QUERY_STATS_CURR_VW or INDEX_STATS_CURR_VW
----------------------------------------------------------------


USE DynamicsPerf
EXEC SP_CAPTURESTATS	@DATABASE_NAME = 'XXXXXXXXX'
						--, @DEBUG = 'Y'
						--, @SKIP_STATS = 'Y'




-- --------------------------------------------------------------
-- Alternatively, run name can also be passed to SP_CAPTURESTATS if desired:
--
--EXEC SP_CAPTURESTATS	@DATABASE_NAME = 'XXXXXXXXXX',
--						@RUN_NAME = 'TEST1'
						
									