USE DynamicsPerf

----------------------------------------------------------------
-- Update the comments for the resolution to a query
-- Use this feature to document fixes and create the documentation
----------------------------------------------------------------


--QUERY_STATS TABLE
UPDATE QUERY_STATS SET COMMENT = ISNULL(COMMENT,'') + '
<my comment here>
'
WHERE ROW_NUM = 999 --<--update with appropriate row_num




-- AX_SQLTRACE TABLE
UPDATE AX_SQLTRACE SET COMMENT = '
<my comment here>
'
WHERE ROW_NUM = 999 --<--update with appropriate row_num


--Display all records with comments, these records are never deleted


SELECT * FROM QUERY_STATS_VW WHERE COMMENT > ''

SELECT * FROM AX_SQLTRACE WHERE COMMENT > ''

----------------------------------------------------------------
-- Display all data captures
----------------------------------------------------------------

SELECT * FROM STATS_COLLECTION_SUMMARY
ORDER BY STATS_TIME DESC


----------------------------------------------------------------
-- Find all the indexes on a specific table
----------------------------------------------------------------

SELECT * FROM INDEX_STATS_CURR_VW
WHERE TABLE_NAME = 'REQTRANS'
--and DATABASE_NAME = '<dbname>'

----------------------------------------------------------------
-- Find Queries referencing an object or field
----------------------------------------------------------------


SELECT TOP 100 *
FROM   QUERY_STATS_CURR_VW
WHERE  SQL_TEXT LIKE '%cust_%'
ORDER  BY TOTAL_ELAPSED_TIME DESC



-- --------------------------------------------------------------
--
-- Queries to investigae SQL Stats on all Indexes and Stats
-- 
-- Only stats for the last collection are kept in the database
-- 
----------------------------------------------------------------

USE DynamicsPerf

SELECT *
FROM   INDEX_DENSITY_VECTOR
WHERE  TABLENAME = '<table name>'
AND DATABASE_NAME = '<DBNAME>'


SELECT *
FROM   INDEX_HISTOGRAM
WHERE  TABLE_NAME = '<table name>'
	   AND COLUMN_NAME = '<column name>'
	   AND DATABASE_NAME = '<DBNAME>'
	   
-- --------------------------------------------------------------
--
-- Query to investigae SQL Density on all Indexes 
-- 
-- Use this query with Trace Flag 4136 to determine how many
-- rows SQL thinks it will return for any 1 column
----------------------------------------------------------------
	   
;WITH Records_CTE (Database_Name,Tablename,Row_count)
AS
-- Define the CTE query.
(
    SELECT DISTINCT DATABASE_NAME, TABLE_NAME,ROW_COUNT
    FROM INDEX_STATS_CURR_VW
)

SELECT dv.DATABASE_NAME,dv.TABLENAME,INDEXNAME,dv.COLUMNS, Row_count, (1/DENSITY) as Number_of_Unique_Values,
Row_count / (1/DENSITY) as Avg_Rows_Per_Value
FROM   INDEX_DENSITY_VECTOR dv Inner join Records_CTE rows on dv.TABLENAME = rows.Tablename and dv.DATABASE_NAME = rows.Database_Name
WHERE  dv.TABLENAME = 'ledgertrans' and COLUMNS = 'accountnum'
