use DynamicsPerf

-------------------------------------------------------------------------------------------------------
--	 1) Creates tables AOTINDEXFIELDS, AOTINDEXPROPERTIES, AOTTABLEPROPERTIES
--       in Database DYNAMICSPERF if they don't exist.
--   2) You must then run AOTEXPORT_EMEA.XPO to populate these tables (PrivateProject_AOTExport_EMEA.xpo)
--
--   These tables are used to populate tables AX_TABLE_DETAIL and AX_INDEX_DETAIL 
--   when we run SP_CAPTURE_STATS
------------------------------------------------------------------------------------------------------

IF NOT EXISTS (SELECT * FROM DYNAMICSPERF.SYS.TABLES WHERE NAME = 'AOTINDEXFIELDS') 
BEGIN

CREATE TABLE [dbo].[AOTINDEXFIELDS](
	[TABLENAME] [nvarchar](40) NOT NULL DEFAULT (''),
	[INDEXNAME] [nvarchar](40) NOT NULL DEFAULT (''),
	[FIELDNAME] [nvarchar](40) NOT NULL DEFAULT (''),
	[FIELDPOSITION] [int] NOT NULL DEFAULT ((0)),
	[CREATEDDATETIME] [datetime] NOT NULL DEFAULT (dateadd(millisecond, -datepart(millisecond,getutcdate()),getutcdate())),
 CONSTRAINT [I_50006FIELDPOSITION] PRIMARY KEY CLUSTERED 
(
	[TABLENAME] ASC,
	[INDEXNAME] ASC,
	[FIELDPOSITION] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]

-- ALTER TABLE [dbo].[AOTINDEXFIELDS]  WITH NOCHECK ADD CHECK  (([RECID]<>(0)))
END 


IF NOT EXISTS (SELECT * FROM DYNAMICSPERF.SYS.TABLES WHERE NAME = 'AOTINDEXPROPERTIES') 
BEGIN


CREATE TABLE [dbo].[AOTINDEXPROPERTIES](
	[INDEXID] [int] NOT NULL DEFAULT ((0)),
	[TABLENAME] [nvarchar](40) NOT NULL DEFAULT (''),
	[INDEXNAME] [nvarchar](40) NOT NULL DEFAULT (''),
	[APPLAYER] [nvarchar](3)NOT NULL DEFAULT (''),
	[ENABLED] [int] NOT NULL DEFAULT ((0)),
	[ALLOWDUPLICATES] [int] NOT NULL DEFAULT ((0)),
	[USAGECOUNT] [int] NOT NULL DEFAULT ((0)),
	[CREATEDDATETIME] [datetime] NOT NULL DEFAULT (dateadd(millisecond, -datepart(millisecond,getutcdate()),getutcdate())),
 CONSTRAINT [I_50007TABLEINDEXNAME] PRIMARY KEY CLUSTERED 
(
	[TABLENAME] ASC,
	[INDEXNAME] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
-- ALTER TABLE [dbo].[AOTINDEXPROPERTIES]  WITH NOCHECK ADD CHECK  (([RECID]<>(0)))

END

IF NOT EXISTS (SELECT * FROM DYNAMICSPERF.SYS.TABLES WHERE NAME = 'AOTTABLEPROPERTIES') 
BEGIN

CREATE TABLE [dbo].[AOTTABLEPROPERTIES](
	[TABLENAME] [nvarchar](40) NOT NULL DEFAULT (''),
	[TABLEGROUP] [int] NOT NULL DEFAULT ((0)),
	[APPLAYER] [nvarchar](3)NOT NULL DEFAULT (''),
	[OCCENABLED] [int] NOT NULL DEFAULT ((0)),
	[CACHELOOKUP] [int] NOT NULL DEFAULT ((0)),
	[PRIMARYKEY] [nvarchar](40) NOT NULL DEFAULT (''),
	[CLUSTEREDINDEX] [nvarchar](40) NOT NULL DEFAULT (''),
	[INSERTMETHODOVERRIDDEN] [int] NOT NULL DEFAULT ((0)),
	[UPDATEMETHODOVERRIDDEN] [int] NOT NULL DEFAULT ((0)),
	[DELETEMETHODOVERRIDDEN] [int] NOT NULL DEFAULT ((0)),
	[DATAPERCOMPANY] [int] NOT NULL DEFAULT ((0)),
	[AOSVALIDATEINSERT] [int] NOT NULL DEFAULT ((0)),
	[AOSVALIDATEUPDATE] [int] NOT NULL DEFAULT ((0)),
	[AOSVALIDATEDELETE] [int] NOT NULL DEFAULT ((0)),
	[DATABASELOGINSERT] [int] NOT NULL DEFAULT ((0)),
	[DATABASELOGDELETE] [int] NOT NULL DEFAULT ((0)),
	[DATABASELOGUPDATE] [int] NOT NULL DEFAULT ((0)),
	[DATABASELOGRENAMEKEY] [int] NOT NULL DEFAULT ((0)),
	[EVENTINSERT] [int] NOT NULL DEFAULT ((0)),
	[EVENTDELETE] [int] NOT NULL DEFAULT ((0)),
	[EVENTUPDATE] [int] NOT NULL DEFAULT ((0)),
	[EVENTRENAMEKEY] [int] NOT NULL DEFAULT ((0)),
	[TABID] [int] NOT NULL DEFAULT ((0)),
	[CREATEDDATETIME] [datetime] NOT NULL DEFAULT (dateadd(millisecond, -datepart(millisecond,getutcdate()),getutcdate())),
 CONSTRAINT [I_50008TABLENAME] PRIMARY KEY CLUSTERED 
(
	[TABLENAME] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]


-- ALTER TABLE [dbo].[AOTTABLEPROPERTIES]  WITH NOCHECK ADD CHECK  (([RECID]<>(0)))
END

