-- TODO
-- change @DATABASE_NAME to customer's production database name
-- change @STATS_DATE to latest stats date/time of last SP_CAPTURESTATS run (see table STATS_COLLECTION_SUMMARY)
----------------------------------------------------------------------------------------------------

USE Dynamicsperf


SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
IF EXISTS (SELECT *
               FROM   sys.objects
               WHERE  object_id = Object_id(N'[dbo].[AX_INDEX_DETAIL]')
                      AND type IN ( N'U' )) 
BEGIN
DROP TABLE [dbo].[AX_INDEX_DETAIL]
END
GO


CREATE TABLE [dbo].[AX_INDEX_DETAIL]
       (
          [STATS_TIME]        [DATETIME] NULL,
          [DATABASE_NAME]     [NVARCHAR](128) NOT NULL,
          [TABLE_NAME]        [NVARCHAR](128) NOT NULL,
          [INDEX_NAME]        [NVARCHAR](128) NOT NULL,
          [INDEX_ID]          [INT] NOT NULL,
          [INDEX_DESCRIPTION] [NVARCHAR](210) NOT NULL,
          [INDEX_KEYS]        [NVARCHAR](MAX) NULL,
		  [APPLAYER] [nvarchar](3) NOT NULL
       )
     ON [PRIMARY] 
     
DECLARE @DATABASE_NAME	NVARCHAR(128),
		@STATS_DATE DATETIME,
		@SQL NVARCHAR(MAX)

-- change this value to customer's production database name
SELECT @DATABASE_NAME = 'MicrosoftDynamicsAX'
-- change this value to latest stats date/time of last SP_CAPTURESTATS run (see table STATS_COLLECTION_SUMMARY)
SELECT @STATS_DATE = '2013-08-27 02:20:00.000'

SET @SQL = 'INSERT INTO DYNAMICSPERF.dbo.AX_TABLE_DETAIL WITH (TABLOCK) ' + ' SELECT ' + '''' + CONVERT(NVARCHAR(24), @STATS_DATE, 121) + ''',' + '''' + @DATABASE_NAME + '''' + ',TABLENAME
	  ,TABID
      ,OCCENABLED
      ,CACHELOOKUP
      ,INSERTMETHODOVERRIDDEN
      ,UPDATEMETHODOVERRIDDEN
      ,DELETEMETHODOVERRIDDEN
      ,AOSVALIDATEINSERT
      ,AOSVALIDATEUPDATE
      ,AOSVALIDATEDELETE
      ,DATABASELOGINSERT
      ,DATABASELOGDELETE
      ,DATABASELOGUPDATE
      ,DATABASELOGRENAMEKEY
      ,EVENTINSERT
      ,EVENTDELETE
      ,EVENTUPDATE
      ,EVENTRENAMEKEY
	,TABLEGROUP
	,APPLAYER
	 FROM AOTTABLEPROPERTIES  WITH (NOLOCK) 
	'
	

EXEC (@SQL) 


SET @SQL = 'INSERT INTO DYNAMICSPERF.dbo.AX_INDEX_DETAIL WITH (TABLOCK) 
	SELECT ' + '''' + CONVERT(NVARCHAR(24), @STATS_DATE, 121) + ''',' + +'''' + @DATABASE_NAME + '''' + ',
	T.TABLENAME,
	INDEXNAME,
	INDEX_ID = INDEXID,
	INDEX_DESCRIPTION = 
		CASE
			WHEN	I.INDEXNAME = T.CLUSTEREDINDEX THEN ''CLUSTERED''
			ELSE	''NONCLUSTERED''
		END +
		CASE
			WHEN	I.ALLOWDUPLICATES = 0 THEN '', UNIQUE''
			ELSE	''''
		END +
		CASE
			WHEN	I.INDEXNAME = T.PRIMARYKEY THEN '', PRIMARY KEY''
			ELSE	''''
		END,
		INDEX_KEYS = 
		CASE 
			WHEN T.DATAPERCOMPANY = 1 AND 0 < 
			(
				SELECT COUNT(*) FROM AOTINDEXFIELDS F WITH (NOLOCK)
				WHERE	F.TABLENAME = I.TABLENAME
				AND		F.INDEXNAME = I.INDEXNAME
				AND		F.FIELDNAME = ''DATAAREAID''
			)	THEN ''''
			WHEN T.DATAPERCOMPANY = 1 THEN '' DATAAREAID,''
			ELSE ''''
		END +
	stuff	
			(
					
				(	
				SELECT '', '' + FIELDNAME
				FROM AOTINDEXFIELDS F  WITH (NOLOCK)
				WHERE F.TABLENAME = I.TABLENAME
				AND FIELDNAME <> ''''
				AND F.INDEXNAME = I.INDEXNAME
				order	by FIELDPOSITION
				for		xml path('''')
				)
			,1,1,''''
			)
			,I.APPLAYER 
					

	FROM	AOTTABLEPROPERTIES	T  WITH (NOLOCK),
			AOTINDEXPROPERTIES	I  WITH (NOLOCK)
	WHERE	T.TABLENAME = I.TABLENAME
'



EXEC (@SQL) 
