--  TODO
--	Change parameter DATABASE_NAME
--	Change parameter RUN_NAME
--	Change parameter STATS_DATE
---------------------------------------------

use DynamicsPerf

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE TABLE [dbo].[AX_NTEXT]
  (
     [RUN_NAME]       NVARCHAR(60) NOT NULL,
     [STATS_TIME]     DATETIME NOT NULL,
     [DATABASE_NAME]  NVARCHAR(128) NULL,
     [TABLE_NAME]     NVARCHAR(255) NOT NULL,
     [COLUMN_NAME]    NVARCHAR(255) NOT NULL,
     [MAX_LENGTH]     INT NULL,
   )
ON [PRIMARY]

GO

CREATE VIEW [dbo].[AX_NTEXT_VW] 
AS
SELECT NT.[RUN_NAME]
      ,NT.[STATS_TIME]
      ,NT.[DATABASE_NAME]
      ,[TABLE_NAME]
      ,[COLUMN_NAME]
      ,[MAX_LENGTH] 
      FROM AX_NTEXT NT
      INNER JOIN     STATS_COLLECTION_SUMMARY S WITH(NOLOCK)
  ON  NT.STATS_TIME = S.STATS_TIME

GO

CREATE VIEW [dbo].[AX_NTEXT_CURR_VW] 
AS
SELECT NT.[RUN_NAME]
      ,NT.[STATS_TIME]
      ,NT.[DATABASE_NAME]
      ,[TABLE_NAME]
      ,[COLUMN_NAME]
      ,[MAX_LENGTH] 
  FROM AX_NTEXT NT
      INNER JOIN     STATS_COLLECTION_SUMMARY S WITH(NOLOCK)
  ON  NT.STATS_TIME = S.STATS_TIME
  WHERE NT.STATS_TIME = (SELECT MAX(STATS_TIME)
                             FROM   STATS_COLLECTION_SUMMARY)
GO



BEGIN
	declare 
	@ColumnName1 varchar(255),
	@TableName1 varchar(255),
	@DATABASE_NAME	NVARCHAR(128),
	@SQL			NVARCHAR(MAX),
	@RUN_NAME		NVARCHAR(60) = NULL,
	@STATS_DATE		DATETIME
	
	set quoted_identifier off
	set ansi_warnings off 

	SET @DATABASE_NAME = 'MicrosoftDynamicsAX'
	SET @RUN_NAME = 'Aug 27 2013  2:20AM'
	SET @STATS_DATE = '2013-08-27 02:20:00.000'
	
	SET @SQL='declare tableCursor CURSOR for select tablename = t.name, columnname = c.name from ['+@DATABASE_NAME+
	'].sys.columns c join ['+@DATABASE_NAME+ '].sys.tables t on c.object_id = t.object_id '+
	'where c.system_type_id = 231 and max_length = -1 order by t.name'

	execute(@SQL)

	OPEN tableCursor

	FETCH TableCursor into @TableName1, @ColumnName1
	WHILE @@Fetch_Status = 0
		  BEGIN
			SET @SQL = 'INSERT INTO AX_NTEXT WITH (TABLOCK) '
			+ ' SELECT ''' + @RUN_NAME  + '''' + ','+'''' + CONVERT(NVARCHAR(24), @STATS_DATE, 121) + ''',' + '''[' + @DATABASE_NAME + ']'',''' 
			+ @TableName1 + ''', '''+@ColumnName1+''',
			maxlength = isnull(max(datalength(' + @ColumnName1 + ')),0)/2 from [' +@DATABASE_NAME+ ']..' + @TableName1
		  
			EXEC (@SQL)          
			FETCH TableCursor into @TableName1, @ColumnName1
		  END
	      
	CLOSE TableCursor
	DEALLOCATE TableCursor

	set quoted_identifier on
	set ansi_warnings on 
END